// ApgTestProgramDlg.cpp : implementation file
//

#include "stdafx.h"
#include "setupapi.h"
#include "ApgTestProgram.h"
#include "ApgTestProgramDlg.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApgTestProgramDlg dialog

CApgTestProgramDlg::CApgTestProgramDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CApgTestProgramDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CApgTestProgramDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hCashDrawer = NULL;
}

void CApgTestProgramDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApgTestProgramDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CApgTestProgramDlg, CDialog)
	//{{AFX_MSG_MAP(CApgTestProgramDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN_THE_DRAWER, OnButtonOpenTheDrawer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApgTestProgramDlg message handlers

BOOL CApgTestProgramDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	HDEVINFO					l_devInfo;
	//HID_DEVICE_DESC		l_HidDevice;
	SP_INTERFACE_DEVICE_DATA	l_hidIntfDev;
	GUID						l_hidGuid;

	// get the GUID for HID
	HidD_GetHidGuid(&l_hidGuid);

	l_devInfo = SetupDiGetClassDevs(
					&l_hidGuid,										
					NULL, // ( const char * ) l_szHappID,				
					NULL,
					DIGCF_INTERFACEDEVICE | DIGCF_PRESENT );
	if (l_devInfo == INVALID_HANDLE_VALUE) {
        AfxMessageBox("No Devices Found",MB_OK);
        return TRUE;
	}

	DWORD l_dwRequiredSize = 0;
	UINT l_nNumCollections = 0;
	BOOL l_fMoreDevices = TRUE;
	BOOL l_fRetBool = FALSE;
	PSP_INTERFACE_DEVICE_DETAIL_DATA	l_pDevDetail = NULL;
	HIDD_ATTRIBUTES						l_hidAttributes;
	PHIDP_PREPARSED_DATA				l_devData;	

	ZeroMemory(&l_hidIntfDev,sizeof(l_hidIntfDev));
	l_hidIntfDev.cbSize = sizeof ( SP_INTERFACE_DEVICE_DATA );

	while (l_fMoreDevices) {
		l_fMoreDevices = SetupDiEnumDeviceInterfaces (
						l_devInfo, 				
						NULL, 					
						&l_hidGuid,				
						l_nNumCollections++, 	
						&l_hidIntfDev );
		if (l_fMoreDevices) {
			l_dwRequiredSize = 0;
			SetupDiGetDeviceInterfaceDetail(
						l_devInfo, 				
						&l_hidIntfDev,					
						NULL, 					
						0, 						
						&l_dwRequiredSize, 		
						NULL);
			if (l_dwRequiredSize) {
				l_pDevDetail = (PSP_INTERFACE_DEVICE_DETAIL_DATA) new char[l_dwRequiredSize];
				ZeroMemory(l_pDevDetail,sizeof(PSP_INTERFACE_DEVICE_DETAIL_DATA));
				l_pDevDetail->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
				l_fRetBool = SetupDiGetDeviceInterfaceDetail(
						l_devInfo, 				
						&l_hidIntfDev,			
						l_pDevDetail,				
						l_dwRequiredSize,			
						NULL, 					
						NULL);
				if (l_fRetBool) {					
					HANDLE l_hDev = CreateFile(
						l_pDevDetail -> DevicePath,		
						GENERIC_READ|GENERIC_WRITE,	
						FILE_SHARE_READ | FILE_SHARE_WRITE, 									
						NULL, 								
						OPEN_EXISTING, 					
						0, //FILE_FLAG_OVERLAPPED,	//0, // FILE_ATTRIBUTE_SYSTEM,FILE_FLAG_OVERLAPPED,			
						NULL);
					if (l_hDev != INVALID_HANDLE_VALUE) {
						l_fRetBool = HidD_GetAttributes( l_hDev, &l_hidAttributes);
						if (l_hidAttributes.VendorID == 0x7c5 && l_hidAttributes.ProductID == 0x500) {
							m_hCashDrawer = l_hDev;
							l_fRetBool = HidD_GetPreparsedData (l_hDev,&l_devData); 
							NTSTATUS l_ntStatus = HidP_GetCaps ( l_devData, &m_devCaps);                                             
							delete l_pDevDetail;
							l_pDevDetail = NULL;
							break;
						}
                        else {
                            CloseHandle(l_hDev);
                        }
					}
				}
				if (l_pDevDetail) {
					delete l_pDevDetail;
					l_pDevDetail = NULL;
				}
			}
		}
	}
	
	CApgTestProgramDlg::OnButtonOpenTheDrawer(); // added by Granite Bear
	DestroyWindow( ); // CDialog::postMessage(null,) // added by Granite Bear to close the window
	return TRUE;  // return TRUE  unless you set the focus to a control
}   //  CApgTestProgramDlg::OnInitDialog


void CApgTestProgramDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CApgTestProgramDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CApgTestProgramDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CApgTestProgramDlg::OnButtonOpenTheDrawer() 
{
	DWORD l_dwBytesWritten = 0;
	char l_szOutputBuffer[7];
	if (m_hCashDrawer) {
		l_szOutputBuffer[0] = 0x0;
		l_szOutputBuffer[1] = 0x0;
		l_szOutputBuffer[2] = 0x1;
		BOOL l_fWriteRes = WriteFile(m_hCashDrawer,l_szOutputBuffer,
			m_devCaps.OutputReportByteLength,&l_dwBytesWritten,NULL);	
		if (!l_fWriteRes) {
			DWORD l_err = GetLastError();
		}
	}
}   //  CApgTestProgramDlg::OnButtonOpenTheDrawer
